request = container.REQUEST
session = request.SESSION
model = request.other['model']
checker = model.service_references


# get the references from the session, if not started
session_key = model.absolute_url(1)+'::linkcheck'
refs = session.get(session_key,None)
if refs is None:
    # just started, or lost references somehow
    # reget the references ant try to commit this soon
    # (i.e. without actually doing checks
    refs = model.get_references(version='previewable')
    session[session_key] = refs
    request.RESPONSE.setHeader('refresh','1; URL=%s/edit/linkchecker_results' % (model.absolute_url(),))
    return [], 'Started reference checking ....'

checker.check_references(refs, timeout=10.0)

ready = 1
for ref in refs:
    if ref.status == ref.STATUS_UNCHECKED and not ref.message:
        ref.set_message('Please test manually.')
    # unpublished references to myself are ok
    if ref.status == ref.STATUS_UNPUBLISHED:
        if checker.get_target_url(ref) == model.absolute_url():
            ref.set_status(ref.STATUS_OK)
    if ref.status == ref.STATUS_UNKNOWN:
        ready = None

broken_refs = checker.filter_broken_references(refs)

if ready:
    msg = None
    # clean from session for next check
    session[session_key] = None
else:
    request.RESPONSE.setHeader('refresh','1; URL=%s/edit/linkchecker_results' % (model.absolute_url(),))
    msg ='Intermediate Result; reference check still running.'
return broken_refs, msg
    

